package eu.mhsl.minenet.minigames.score;

import eu.mhsl.minenet.minigames.message.TranslatableMessage;
import eu.mhsl.minenet.minigames.message.type.TitleMessage;
import eu.mhsl.minenet.minigames.util.MapUtil;
import net.minestom.server.entity.Player;

import java.time.Duration;
import java.util.*;

public class PointsWinScore extends Score {
    private Map<Set<Player>, Integer> scoreOrder = new HashMap<>();

    @Override
    public void insertResultImplementation(Set<Player> p, int points) {
        this.scoreOrder.put(p, points);
        this.scoreOrder = MapUtil.sortByValue(this.scoreOrder);
        getScores().clear();
        this.scoreOrder.forEach((player, integer) -> getScores().addFirst(player));
    }

    @Override
    protected void insertResultImplementation(Set<Player> p) {
        this.insertResultImplementation(p, 0);
    }

    @Override
    public void insertResult(Player p, int points) {
        if(hasResult(p)) return;
        this.scoreMessage().send(p);
        this.insertResultImplementation(Set.of(p), points);
        this.checkGameEnd();
    }

    @Override
    protected TranslatableMessage scoreMessage() {
        return new TitleMessage(Duration.ofMillis(1000), Duration.ofSeconds(1)).appendTranslated("score#death");
    }
}
